// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-analytics-dtos.proto

package com.accelfin.server.demo.analytics.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto}
 */
public  final class FxAlertReportUpdateRequestDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto)
    FxAlertReportUpdateRequestDtoOrBuilder {
  // Use FxAlertReportUpdateRequestDto.newBuilder() to construct.
  private FxAlertReportUpdateRequestDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private FxAlertReportUpdateRequestDto() {
    reportId_ = "";
    reportType_ = 0;
    symbols_ = com.google.protobuf.LazyStringArrayList.EMPTY;
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private FxAlertReportUpdateRequestDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            reportId_ = s;
            break;
          }
          case 16: {
            int rawValue = input.readEnum();

            reportType_ = rawValue;
            break;
          }
          case 26: {
            java.lang.String s = input.readStringRequireUtf8();
            if (!((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
              symbols_ = new com.google.protobuf.LazyStringArrayList();
              mutable_bitField0_ |= 0x00000004;
            }
            symbols_.add(s);
            break;
          }
          case 34: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (rangeViewStart_ != null) {
              subBuilder = rangeViewStart_.toBuilder();
            }
            rangeViewStart_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(rangeViewStart_);
              rangeViewStart_ = subBuilder.buildPartial();
            }

            break;
          }
          case 42: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (rangeViewEnd_ != null) {
              subBuilder = rangeViewEnd_.toBuilder();
            }
            rangeViewEnd_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(rangeViewEnd_);
              rangeViewEnd_ = subBuilder.buildPartial();
            }

            break;
          }
          case 50: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (mainViewStart_ != null) {
              subBuilder = mainViewStart_.toBuilder();
            }
            mainViewStart_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(mainViewStart_);
              mainViewStart_ = subBuilder.buildPartial();
            }

            break;
          }
          case 58: {
            com.accelfin.server.messaging.dtos.TimestampDto.Builder subBuilder = null;
            if (mainViewEnd_ != null) {
              subBuilder = mainViewEnd_.toBuilder();
            }
            mainViewEnd_ = input.readMessage(com.accelfin.server.messaging.dtos.TimestampDto.parser(), extensionRegistry);
            if (subBuilder != null) {
              subBuilder.mergeFrom(mainViewEnd_);
              mainViewEnd_ = subBuilder.buildPartial();
            }

            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000004) == 0x00000004)) {
        symbols_ = symbols_.getUnmodifiableView();
      }
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertReportUpdateRequestDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertReportUpdateRequestDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.Builder.class);
  }

  private int bitField0_;
  public static final int REPORT_ID_FIELD_NUMBER = 1;
  private volatile java.lang.Object reportId_;
  /**
   * <code>optional string report_id = 1;</code>
   */
  public java.lang.String getReportId() {
    java.lang.Object ref = reportId_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      reportId_ = s;
      return s;
    }
  }
  /**
   * <code>optional string report_id = 1;</code>
   */
  public com.google.protobuf.ByteString
      getReportIdBytes() {
    java.lang.Object ref = reportId_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      reportId_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int REPORT_TYPE_FIELD_NUMBER = 2;
  private int reportType_;
  /**
   * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
   */
  public int getReportTypeValue() {
    return reportType_;
  }
  /**
   * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
   */
  public com.accelfin.server.demo.analytics.dtos.ReportTypeDto getReportType() {
    com.accelfin.server.demo.analytics.dtos.ReportTypeDto result = com.accelfin.server.demo.analytics.dtos.ReportTypeDto.forNumber(reportType_);
    return result == null ? com.accelfin.server.demo.analytics.dtos.ReportTypeDto.UNRECOGNIZED : result;
  }

  public static final int SYMBOLS_FIELD_NUMBER = 3;
  private com.google.protobuf.LazyStringList symbols_;
  /**
   * <code>repeated string symbols = 3;</code>
   */
  public com.google.protobuf.ProtocolStringList
      getSymbolsList() {
    return symbols_;
  }
  /**
   * <code>repeated string symbols = 3;</code>
   */
  public int getSymbolsCount() {
    return symbols_.size();
  }
  /**
   * <code>repeated string symbols = 3;</code>
   */
  public java.lang.String getSymbols(int index) {
    return symbols_.get(index);
  }
  /**
   * <code>repeated string symbols = 3;</code>
   */
  public com.google.protobuf.ByteString
      getSymbolsBytes(int index) {
    return symbols_.getByteString(index);
  }

  public static final int RANGE_VIEW_START_FIELD_NUMBER = 4;
  private com.accelfin.server.messaging.dtos.TimestampDto rangeViewStart_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
   */
  public boolean hasRangeViewStart() {
    return rangeViewStart_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getRangeViewStart() {
    return rangeViewStart_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewStart_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getRangeViewStartOrBuilder() {
    return getRangeViewStart();
  }

  public static final int RANGE_VIEW_END_FIELD_NUMBER = 5;
  private com.accelfin.server.messaging.dtos.TimestampDto rangeViewEnd_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
   */
  public boolean hasRangeViewEnd() {
    return rangeViewEnd_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getRangeViewEnd() {
    return rangeViewEnd_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewEnd_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getRangeViewEndOrBuilder() {
    return getRangeViewEnd();
  }

  public static final int MAIN_VIEW_START_FIELD_NUMBER = 6;
  private com.accelfin.server.messaging.dtos.TimestampDto mainViewStart_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
   */
  public boolean hasMainViewStart() {
    return mainViewStart_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getMainViewStart() {
    return mainViewStart_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewStart_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getMainViewStartOrBuilder() {
    return getMainViewStart();
  }

  public static final int MAIN_VIEW_END_FIELD_NUMBER = 7;
  private com.accelfin.server.messaging.dtos.TimestampDto mainViewEnd_;
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
   */
  public boolean hasMainViewEnd() {
    return mainViewEnd_ != null;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDto getMainViewEnd() {
    return mainViewEnd_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewEnd_;
  }
  /**
   * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
   */
  public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getMainViewEndOrBuilder() {
    return getMainViewEnd();
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getReportIdBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, reportId_);
    }
    if (reportType_ != com.accelfin.server.demo.analytics.dtos.ReportTypeDto.FX_ALERTS.getNumber()) {
      output.writeEnum(2, reportType_);
    }
    for (int i = 0; i < symbols_.size(); i++) {
      com.google.protobuf.GeneratedMessage.writeString(output, 3, symbols_.getRaw(i));
    }
    if (rangeViewStart_ != null) {
      output.writeMessage(4, getRangeViewStart());
    }
    if (rangeViewEnd_ != null) {
      output.writeMessage(5, getRangeViewEnd());
    }
    if (mainViewStart_ != null) {
      output.writeMessage(6, getMainViewStart());
    }
    if (mainViewEnd_ != null) {
      output.writeMessage(7, getMainViewEnd());
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getReportIdBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, reportId_);
    }
    if (reportType_ != com.accelfin.server.demo.analytics.dtos.ReportTypeDto.FX_ALERTS.getNumber()) {
      size += com.google.protobuf.CodedOutputStream
        .computeEnumSize(2, reportType_);
    }
    {
      int dataSize = 0;
      for (int i = 0; i < symbols_.size(); i++) {
        dataSize += computeStringSizeNoTag(symbols_.getRaw(i));
      }
      size += dataSize;
      size += 1 * getSymbolsList().size();
    }
    if (rangeViewStart_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getRangeViewStart());
    }
    if (rangeViewEnd_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getRangeViewEnd());
    }
    if (mainViewStart_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getMainViewStart());
    }
    if (mainViewEnd_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(7, getMainViewEnd());
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto)
      com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertReportUpdateRequestDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertReportUpdateRequestDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.class, com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
      }
    }
    public Builder clear() {
      super.clear();
      reportId_ = "";

      reportType_ = 0;

      symbols_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000004);
      if (rangeViewStartBuilder_ == null) {
        rangeViewStart_ = null;
      } else {
        rangeViewStart_ = null;
        rangeViewStartBuilder_ = null;
      }
      if (rangeViewEndBuilder_ == null) {
        rangeViewEnd_ = null;
      } else {
        rangeViewEnd_ = null;
        rangeViewEndBuilder_ = null;
      }
      if (mainViewStartBuilder_ == null) {
        mainViewStart_ = null;
      } else {
        mainViewStart_ = null;
        mainViewStartBuilder_ = null;
      }
      if (mainViewEndBuilder_ == null) {
        mainViewEnd_ = null;
      } else {
        mainViewEnd_ = null;
        mainViewEndBuilder_ = null;
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.analytics.dtos.AccelfinServerDemoAnalyticsDtos.internal_static_com_accelfin_server_demo_analytics_dtos_FxAlertReportUpdateRequestDto_descriptor;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto build() {
      com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto buildPartial() {
      com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto result = new com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.reportId_ = reportId_;
      result.reportType_ = reportType_;
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        symbols_ = symbols_.getUnmodifiableView();
        bitField0_ = (bitField0_ & ~0x00000004);
      }
      result.symbols_ = symbols_;
      if (rangeViewStartBuilder_ == null) {
        result.rangeViewStart_ = rangeViewStart_;
      } else {
        result.rangeViewStart_ = rangeViewStartBuilder_.build();
      }
      if (rangeViewEndBuilder_ == null) {
        result.rangeViewEnd_ = rangeViewEnd_;
      } else {
        result.rangeViewEnd_ = rangeViewEndBuilder_.build();
      }
      if (mainViewStartBuilder_ == null) {
        result.mainViewStart_ = mainViewStart_;
      } else {
        result.mainViewStart_ = mainViewStartBuilder_.build();
      }
      if (mainViewEndBuilder_ == null) {
        result.mainViewEnd_ = mainViewEnd_;
      } else {
        result.mainViewEnd_ = mainViewEndBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto) {
        return mergeFrom((com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto other) {
      if (other == com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto.getDefaultInstance()) return this;
      if (!other.getReportId().isEmpty()) {
        reportId_ = other.reportId_;
        onChanged();
      }
      if (other.reportType_ != 0) {
        setReportTypeValue(other.getReportTypeValue());
      }
      if (!other.symbols_.isEmpty()) {
        if (symbols_.isEmpty()) {
          symbols_ = other.symbols_;
          bitField0_ = (bitField0_ & ~0x00000004);
        } else {
          ensureSymbolsIsMutable();
          symbols_.addAll(other.symbols_);
        }
        onChanged();
      }
      if (other.hasRangeViewStart()) {
        mergeRangeViewStart(other.getRangeViewStart());
      }
      if (other.hasRangeViewEnd()) {
        mergeRangeViewEnd(other.getRangeViewEnd());
      }
      if (other.hasMainViewStart()) {
        mergeMainViewStart(other.getMainViewStart());
      }
      if (other.hasMainViewEnd()) {
        mergeMainViewEnd(other.getMainViewEnd());
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object reportId_ = "";
    /**
     * <code>optional string report_id = 1;</code>
     */
    public java.lang.String getReportId() {
      java.lang.Object ref = reportId_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        reportId_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public com.google.protobuf.ByteString
        getReportIdBytes() {
      java.lang.Object ref = reportId_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        reportId_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder setReportId(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      reportId_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder clearReportId() {
      
      reportId_ = getDefaultInstance().getReportId();
      onChanged();
      return this;
    }
    /**
     * <code>optional string report_id = 1;</code>
     */
    public Builder setReportIdBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      reportId_ = value;
      onChanged();
      return this;
    }

    private int reportType_ = 0;
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public int getReportTypeValue() {
      return reportType_;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder setReportTypeValue(int value) {
      reportType_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public com.accelfin.server.demo.analytics.dtos.ReportTypeDto getReportType() {
      com.accelfin.server.demo.analytics.dtos.ReportTypeDto result = com.accelfin.server.demo.analytics.dtos.ReportTypeDto.forNumber(reportType_);
      return result == null ? com.accelfin.server.demo.analytics.dtos.ReportTypeDto.UNRECOGNIZED : result;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder setReportType(com.accelfin.server.demo.analytics.dtos.ReportTypeDto value) {
      if (value == null) {
        throw new NullPointerException();
      }
      
      reportType_ = value.getNumber();
      onChanged();
      return this;
    }
    /**
     * <code>optional .com.accelfin.server.demo.analytics.dtos.ReportTypeDto report_type = 2;</code>
     */
    public Builder clearReportType() {
      
      reportType_ = 0;
      onChanged();
      return this;
    }

    private com.google.protobuf.LazyStringList symbols_ = com.google.protobuf.LazyStringArrayList.EMPTY;
    private void ensureSymbolsIsMutable() {
      if (!((bitField0_ & 0x00000004) == 0x00000004)) {
        symbols_ = new com.google.protobuf.LazyStringArrayList(symbols_);
        bitField0_ |= 0x00000004;
       }
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public com.google.protobuf.ProtocolStringList
        getSymbolsList() {
      return symbols_.getUnmodifiableView();
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public int getSymbolsCount() {
      return symbols_.size();
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public java.lang.String getSymbols(int index) {
      return symbols_.get(index);
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public com.google.protobuf.ByteString
        getSymbolsBytes(int index) {
      return symbols_.getByteString(index);
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public Builder setSymbols(
        int index, java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  ensureSymbolsIsMutable();
      symbols_.set(index, value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public Builder addSymbols(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  ensureSymbolsIsMutable();
      symbols_.add(value);
      onChanged();
      return this;
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public Builder addAllSymbols(
        java.lang.Iterable<java.lang.String> values) {
      ensureSymbolsIsMutable();
      com.google.protobuf.AbstractMessageLite.Builder.addAll(
          values, symbols_);
      onChanged();
      return this;
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public Builder clearSymbols() {
      symbols_ = com.google.protobuf.LazyStringArrayList.EMPTY;
      bitField0_ = (bitField0_ & ~0x00000004);
      onChanged();
      return this;
    }
    /**
     * <code>repeated string symbols = 3;</code>
     */
    public Builder addSymbolsBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      ensureSymbolsIsMutable();
      symbols_.add(value);
      onChanged();
      return this;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto rangeViewStart_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> rangeViewStartBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public boolean hasRangeViewStart() {
      return rangeViewStartBuilder_ != null || rangeViewStart_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getRangeViewStart() {
      if (rangeViewStartBuilder_ == null) {
        return rangeViewStart_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewStart_;
      } else {
        return rangeViewStartBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public Builder setRangeViewStart(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (rangeViewStartBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        rangeViewStart_ = value;
        onChanged();
      } else {
        rangeViewStartBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public Builder setRangeViewStart(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (rangeViewStartBuilder_ == null) {
        rangeViewStart_ = builderForValue.build();
        onChanged();
      } else {
        rangeViewStartBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public Builder mergeRangeViewStart(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (rangeViewStartBuilder_ == null) {
        if (rangeViewStart_ != null) {
          rangeViewStart_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(rangeViewStart_).mergeFrom(value).buildPartial();
        } else {
          rangeViewStart_ = value;
        }
        onChanged();
      } else {
        rangeViewStartBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public Builder clearRangeViewStart() {
      if (rangeViewStartBuilder_ == null) {
        rangeViewStart_ = null;
        onChanged();
      } else {
        rangeViewStart_ = null;
        rangeViewStartBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getRangeViewStartBuilder() {
      
      onChanged();
      return getRangeViewStartFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getRangeViewStartOrBuilder() {
      if (rangeViewStartBuilder_ != null) {
        return rangeViewStartBuilder_.getMessageOrBuilder();
      } else {
        return rangeViewStart_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewStart_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_start = 4;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getRangeViewStartFieldBuilder() {
      if (rangeViewStartBuilder_ == null) {
        rangeViewStartBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getRangeViewStart(),
                getParentForChildren(),
                isClean());
        rangeViewStart_ = null;
      }
      return rangeViewStartBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto rangeViewEnd_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> rangeViewEndBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public boolean hasRangeViewEnd() {
      return rangeViewEndBuilder_ != null || rangeViewEnd_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getRangeViewEnd() {
      if (rangeViewEndBuilder_ == null) {
        return rangeViewEnd_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewEnd_;
      } else {
        return rangeViewEndBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public Builder setRangeViewEnd(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (rangeViewEndBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        rangeViewEnd_ = value;
        onChanged();
      } else {
        rangeViewEndBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public Builder setRangeViewEnd(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (rangeViewEndBuilder_ == null) {
        rangeViewEnd_ = builderForValue.build();
        onChanged();
      } else {
        rangeViewEndBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public Builder mergeRangeViewEnd(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (rangeViewEndBuilder_ == null) {
        if (rangeViewEnd_ != null) {
          rangeViewEnd_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(rangeViewEnd_).mergeFrom(value).buildPartial();
        } else {
          rangeViewEnd_ = value;
        }
        onChanged();
      } else {
        rangeViewEndBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public Builder clearRangeViewEnd() {
      if (rangeViewEndBuilder_ == null) {
        rangeViewEnd_ = null;
        onChanged();
      } else {
        rangeViewEnd_ = null;
        rangeViewEndBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getRangeViewEndBuilder() {
      
      onChanged();
      return getRangeViewEndFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getRangeViewEndOrBuilder() {
      if (rangeViewEndBuilder_ != null) {
        return rangeViewEndBuilder_.getMessageOrBuilder();
      } else {
        return rangeViewEnd_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : rangeViewEnd_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto range_view_end = 5;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getRangeViewEndFieldBuilder() {
      if (rangeViewEndBuilder_ == null) {
        rangeViewEndBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getRangeViewEnd(),
                getParentForChildren(),
                isClean());
        rangeViewEnd_ = null;
      }
      return rangeViewEndBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto mainViewStart_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> mainViewStartBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public boolean hasMainViewStart() {
      return mainViewStartBuilder_ != null || mainViewStart_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getMainViewStart() {
      if (mainViewStartBuilder_ == null) {
        return mainViewStart_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewStart_;
      } else {
        return mainViewStartBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public Builder setMainViewStart(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (mainViewStartBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        mainViewStart_ = value;
        onChanged();
      } else {
        mainViewStartBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public Builder setMainViewStart(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (mainViewStartBuilder_ == null) {
        mainViewStart_ = builderForValue.build();
        onChanged();
      } else {
        mainViewStartBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public Builder mergeMainViewStart(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (mainViewStartBuilder_ == null) {
        if (mainViewStart_ != null) {
          mainViewStart_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(mainViewStart_).mergeFrom(value).buildPartial();
        } else {
          mainViewStart_ = value;
        }
        onChanged();
      } else {
        mainViewStartBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public Builder clearMainViewStart() {
      if (mainViewStartBuilder_ == null) {
        mainViewStart_ = null;
        onChanged();
      } else {
        mainViewStart_ = null;
        mainViewStartBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getMainViewStartBuilder() {
      
      onChanged();
      return getMainViewStartFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getMainViewStartOrBuilder() {
      if (mainViewStartBuilder_ != null) {
        return mainViewStartBuilder_.getMessageOrBuilder();
      } else {
        return mainViewStart_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewStart_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_start = 6;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getMainViewStartFieldBuilder() {
      if (mainViewStartBuilder_ == null) {
        mainViewStartBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getMainViewStart(),
                getParentForChildren(),
                isClean());
        mainViewStart_ = null;
      }
      return mainViewStartBuilder_;
    }

    private com.accelfin.server.messaging.dtos.TimestampDto mainViewEnd_ = null;
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> mainViewEndBuilder_;
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public boolean hasMainViewEnd() {
      return mainViewEndBuilder_ != null || mainViewEnd_ != null;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto getMainViewEnd() {
      if (mainViewEndBuilder_ == null) {
        return mainViewEnd_ == null ? com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewEnd_;
      } else {
        return mainViewEndBuilder_.getMessage();
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public Builder setMainViewEnd(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (mainViewEndBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        mainViewEnd_ = value;
        onChanged();
      } else {
        mainViewEndBuilder_.setMessage(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public Builder setMainViewEnd(
        com.accelfin.server.messaging.dtos.TimestampDto.Builder builderForValue) {
      if (mainViewEndBuilder_ == null) {
        mainViewEnd_ = builderForValue.build();
        onChanged();
      } else {
        mainViewEndBuilder_.setMessage(builderForValue.build());
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public Builder mergeMainViewEnd(com.accelfin.server.messaging.dtos.TimestampDto value) {
      if (mainViewEndBuilder_ == null) {
        if (mainViewEnd_ != null) {
          mainViewEnd_ =
            com.accelfin.server.messaging.dtos.TimestampDto.newBuilder(mainViewEnd_).mergeFrom(value).buildPartial();
        } else {
          mainViewEnd_ = value;
        }
        onChanged();
      } else {
        mainViewEndBuilder_.mergeFrom(value);
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public Builder clearMainViewEnd() {
      if (mainViewEndBuilder_ == null) {
        mainViewEnd_ = null;
        onChanged();
      } else {
        mainViewEnd_ = null;
        mainViewEndBuilder_ = null;
      }

      return this;
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDto.Builder getMainViewEndBuilder() {
      
      onChanged();
      return getMainViewEndFieldBuilder().getBuilder();
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    public com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder getMainViewEndOrBuilder() {
      if (mainViewEndBuilder_ != null) {
        return mainViewEndBuilder_.getMessageOrBuilder();
      } else {
        return mainViewEnd_ == null ?
            com.accelfin.server.messaging.dtos.TimestampDto.getDefaultInstance() : mainViewEnd_;
      }
    }
    /**
     * <code>optional .com.accelfin.server.messaging.dtos.TimestampDto main_view_end = 7;</code>
     */
    private com.google.protobuf.SingleFieldBuilder<
        com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder> 
        getMainViewEndFieldBuilder() {
      if (mainViewEndBuilder_ == null) {
        mainViewEndBuilder_ = new com.google.protobuf.SingleFieldBuilder<
            com.accelfin.server.messaging.dtos.TimestampDto, com.accelfin.server.messaging.dtos.TimestampDto.Builder, com.accelfin.server.messaging.dtos.TimestampDtoOrBuilder>(
                getMainViewEnd(),
                getParentForChildren(),
                isClean());
        mainViewEnd_ = null;
      }
      return mainViewEndBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto)
  private static final com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto();
  }

  public static com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<FxAlertReportUpdateRequestDto>
      PARSER = new com.google.protobuf.AbstractParser<FxAlertReportUpdateRequestDto>() {
    public FxAlertReportUpdateRequestDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new FxAlertReportUpdateRequestDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<FxAlertReportUpdateRequestDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<FxAlertReportUpdateRequestDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.analytics.dtos.FxAlertReportUpdateRequestDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

